

extern "C" {
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
}

/*
 
 
 1: ice spawns polar bears instead of birds
 2: comma in thing
 3: extra had in final dialog (or penultimate)
 4:animals only move right
 
todo:
 
4 extra building corners (maybe just upper 2 actually)
 randomise grass tiles
 add 'npc' tile, and outcast tile (must be 4 in each area), to be turned into grass 
 same for enemy tiles
 
 and a starting poitn tile (also grass)
 
 (maybe have just one town, with LOTS of worldmap variations, that you can 'repeat' twice (with different maps; in one occurence cast as the enemy))
 
 outline green trees
 
 
 GREEN tile
 ROAD tile
 GRASSYHILL tile 
 SANDYHILL tile (can reuse some code here I think)
 STAIRS tile
 ICE tile
 SWAMP tile
 TRANSITION tile??(dangerous...let's not...)
 WATER tile
 
 place cities on opposite diagonals
 wilderness in the middle
 put bandit camp beside city, wilderness in two other adjacent squares
 
 something interesting in the middle
 
 one (easy) off-quest goes before gun, one goes after

 put interesting things in the two other diagonal squares
 
 (will be able to use "east","north-east",&c.);

 //BOOST.FORMAT MIGHT BE USEFUL
 
 (add adjacentcity tag)
 
 healthpacks!
 
 when you die, restart in city next to benevolent npc (who you should start next to)
 
 enemies respawn once they are dead and you are more than a distance X from their spawning location
 
 HAVE npc1 npc2 npc3 npc4 &c. tags (or maybe have just four, with others having special implicit numbers)
 
 need a relpos function
 (for that will need a sector function?)
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <map>
#include <string>
#include <time.h>
#include <algorithm>
#include "boost/foreach.hpp"
#include <lua.h> 

#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif

using namespace std;

#define foreach BOOST_FOREACH

typedef float num;

#include "sound.hpp"
#include "timer.hpp"
#include "game.hpp"

void init_gamevars();

BITMAP* bmp_title;
BITMAP* bmp_tiles;
BITMAP* bmp_textbox;

BITMAP* fontbmp[36];
BITMAP* buffer;

bool gameover=false;
bool quit=false;


bool nowdown[5];//keeps track of keypresses

void introloop()
{
	speed_count=0;
	int titletimer=0;
	
	
	
	
	while (!quit&&!gameover&&(titletimer<60))
	{
		
		al_poll_duh(dplay);	

    	while(speed_count>0){
			
			titletimer++;
			
			
			if (key[KEY_ESC]||key[KEY_Z])
				return;
						
		      speed_count--;
		}
		
		clear_to_color(buffer,makecol(50,56,55));
				
		textout_ex(buffer, font, "increpare presents", 8, 50, makecol(116,130,127), makecol(50,56,55));
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
}


void titleloop()
{
	
	speed_count=0;
	bool escprev=false;
	bool zprev=false;
	
	while (!quit)
	{
		
		al_poll_duh(dplay);	
		

		while(speed_count>0)
		{
			if (key[KEY_ESC])
			{
				if (escprev)
					quit=true;
			}
			else
			{
				escprev=true;
			}
			
			if (key[KEY_Z])
			{
				if (zprev)
				{
					playblip(0);
					return;
				}
			}
			else
			{
				zprev=true;
			}
			
			speed_count--;
		} 
		
		
		blit(bmp_title, buffer, 0, 0, 0, 0, 160, 120);
		
			
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
	
}


int do_logic()
{
	
	return 0;
}


const int tilesize=16;
const int xmargin=4;//offsets of top-left fully-visible tile
const int ymargin=4;
const int tiles=7;
int moveticker;



int nearnpc()
{
	int tx=px;
	int ty=py;
	switch (pdir)
	{
		case 0:
			ty--;
			break;
		case 1:
			ty++;
			break;
		case 2:
			tx--;
			break;
		case 3:
			tx++;
			break;
	}
	
	for (unsigned int i=0;i<npc.size();i++)
	{
		if ((npc[i].x==tx) && (npc[i].y==ty))
		{
			return i;
		}
	}
	return -1;
}


void drawnpcs(int offx, int offy)
{


	foreach(Entity n,entities)
	{
		if (abs(n.x-px)<10 && abs(n.y-py)<10)
			masked_blit(bmp_tiles, buffer, (n.tile%16)*tilesize,(n.tile/16)*tilesize, (n.x-offx)*tilesize+xmargin,(n.y-offy)*tilesize+ymargin , tilesize, tilesize);
	}
	
	for (int i=0;i<9;i++)
	{
		if (abs(npc[i].x-px)<10 && abs(npc[i].y-py)<10)
		{
			masked_blit(bmp_tiles, buffer, (npc[i].tile%16)*tilesize,(npc[i].tile/16)*tilesize, (npc[i].x-offx)*tilesize+xmargin,(npc[i].y-offy)*tilesize+ymargin , tilesize, tilesize);
			
			if (scripts[scriptindex].kind==s_wait
				&&
				scripts[scriptindex].data.waitdata.waitkind==w_talk &&
				scripts[scriptindex].data.waitdata.target==i)
			{//draw exclamation mark
				if (!showingdialog)
					masked_blit(bmp_tiles,buffer,11*tilesize,7*tilesize, (npc[i].x-offx)*tilesize+xmargin,(npc[i].y-offy)*tilesize+ymargin-17,tilesize,tilesize);
			}
		}
	}
	
}



void trymove(int x, int y)
{
	if (canmoveto(x,y))
	{
		px=x;
		py=y;
	}
}

//just movement, no shooting
void do_move()
{
		moveticker=(moveticker+1)%5;
	
	
	if (key[KEY_UP])
	{
		if (!nowdown[0])
		{
			pdir=0;	
			trymove(px,py-1);
			moveticker=0;
		}
		else
		{
			if (moveticker==0 && pdir==0)
				trymove(px,py-1);
		}
		nowdown[0]=true;
	}
	else
	{
		if (nowdown[0])
		{
			for (int i=0;i<4;i++)
				nowdown[i]=false;
			
			do_move();
			return;
		}
	}
	
	
	if (key[KEY_DOWN])
	{
		if (!nowdown[1])
		{
			pdir=1;
			trymove(px,py+1);
			moveticker=0;			
		}
		else
		{
			if (moveticker==0 && pdir==1)
				trymove(px,py+1);
		}
		nowdown[1]=true;
	}
	else
	{
		if (nowdown[1])
		{
			for (int i=0;i<4;i++)
				nowdown[i]=false;
			
			do_move();
			return;
		}
	}
	
	
	if (key[KEY_LEFT])
	{
		if (!nowdown[2])
		{
			pdir=2;			
			trymove(px-1,py);
			moveticker=0;	
		}
		else
		{
			if (moveticker==0 && pdir==2)
				trymove(px-1,py);
		}
		nowdown[2]=true;
	}
	else
	{
		if (nowdown[2])
		{
			for (int i=0;i<4;i++)
				nowdown[i]=false;
			
			do_move();
			return;	
		}
	}
	
	
	if (key[KEY_RIGHT])
	{
		if (!nowdown[3])
		{
			pdir=3;			
			if (canmoveto(px+1,py))
				trymove(px+1,py);
			moveticker=0;			
		}
		else
		{
			if (moveticker==0 && pdir==3)
				trymove(px+1,py);
		}
		nowdown[3]=true;
	}
	else
	{
		if (nowdown[3])
		{
			for (int i=0;i<4;i++)
				nowdown[i]=false;
			
			do_move();
			return;
		}		
		
	}
	
}

int curentitymoving=0;

void game_input()
{
	if (showingdialog)
	{
		if (key[KEY_Z])
		{
			if (!nowdown[4])
			{
				showingdialog=false;
				do_script();
			}
			nowdown[4]=true;
			return;
		}
		else
		{
			nowdown[4]=false;
		}
		return;
	}

	do_move();
	
	
	for (unsigned int i=0;i<entities.size();i++)
	{
		if ((abs(entities[i].x-px)+abs(entities[i].y-py)) < 20)
			entities[i].move();
	}

	
	if (key[KEY_Z])
	{
		if (!nowdown[4])
		{
			int r=nearnpc();
			if (r>=0)
			{

				//check if it's a goal
				if (scripts[scriptindex].kind==s_wait && 
					scripts[scriptindex].data.waitdata.waitkind==w_talk &&
					scripts[scriptindex].data.waitdata.target==r)
				{
					scriptindex++;
					if (scriptindex<scripts.size())
					{
						do_script();
					}
					else
					{
						finishedscripts=true;//game will end when dialogue closed						
					}
				}
				else
				{
					//otherwise generic texts
					say(npc[r].text);
				}
			}
			else
			{
				//SHOOOOOT/KNIFEsomething (includes checking for vines)
			}
		}
		nowdown[4]=true;
		return;
	}
	else
	{
		nowdown[4]=false;
	}
	
}

int chartonum(char c)
{
	if ((c>='a')&&(c<='z'))
		return c-'a';
	else if ((c>='A')&&(c<='Z'))
		return (c-'A');
	else if ((c>='0')&&(c<='9'))
		return 26+c-'0';
	else return 0;
}

void printtext(int x, int y, const char* text)
{
	int i=0;
	while (text[i]!=0)
	{
		if (text[i]!=' ')
			masked_blit(fontbmp[chartonum(text[i])],buffer,0,0,x+4*i,y,3,5);
		i++;
	}
}

void printtextml(int x, int y, unsigned int width, const string& text)
{
	if (width==0)
        return;
	int cury=y;
	
    string s=text;
	unsigned int startp=0;
    while (startp<s.size())
    {
        unsigned int endp=startp+1;
        int lastspace=-1;
		
        while (endp-startp<=width)
        {
			
            if (endp==s.size())
            {
                lastspace=endp;
                break;
            }
            if (s[endp]=='\n')
            {
                lastspace=endp;
                break;
            }
            else if (s[endp]==' ')
            {
                lastspace=endp;
            }
            endp++;
        }
		
        if (lastspace>=0)//wrap a word around
        {
            //if two consecutive newlines
            if (s.substr(startp,lastspace-startp)=="\n")
            {
                startp=lastspace+1;
            }
            else
            {
                printtext(x,cury,s.substr(startp,lastspace-startp).c_str());
                startp=lastspace+1;
            }
        }
        else //word bigger than line, just thunk
        {
            printtext(x,cury,s.substr(startp,endp-startp).c_str());
            startp+=width;
        }
		
        cury+=6;
		
    }	
}

void drawmap()
{
	
	
	//DRAW TERRAIN
	
	int mapoffsetx;
	int mapoffsety;
		
	if (px<4)
	{
		mapoffsetx=1;
	}
	else if (px>mapwidth-5)
	{	
		mapoffsetx=mapwidth-tiles-1;//for margin
	}
	else
	{
		mapoffsetx=px-3;
	}
	
	if (py<4)
	{
		mapoffsety=1;
	}
	else if (py>mapheight-5)
	{	
		mapoffsety=mapheight-tiles-1;//for margin
	}
	else
	{
		mapoffsety=py-3;
	}
	
	
	for (int i=0;i<tiles;i++)
	{
		for (int j=0;j<tiles;j++)
		{
			blit(bmp_tiles, buffer,( worldmap[mapoffsetx+i][mapoffsety+j]%tilemap_tw)*tilesize,( worldmap[mapoffsetx+i][mapoffsety+j]/tilemap_th)*tilesize,  xmargin+tilesize*i, ymargin+tilesize*j, tilesize, tilesize);
		}
	}
	

	
	//draw half-tiles around margin
	
	//top and bottom
	for (int i=0;i<tiles;i++)
	{
		//top first
		blit(bmp_tiles, buffer, (worldmap[mapoffsetx+i][mapoffsety-1]%tilemap_tw)*tilesize, (worldmap[mapoffsetx+i][mapoffsety-1]/tilemap_tw)*tilesize+tilesize-tilesize/4,  ymargin+tilesize*i, 0, tilesize, tilesize/4);		
		blit(bmp_tiles, buffer, (worldmap[mapoffsetx+i][mapoffsety+tiles]%tilemap_tw)*tilesize,(worldmap[mapoffsetx+i][mapoffsety+tiles]/tilemap_tw)*tilesize,  xmargin+tilesize*i,120-ymargin, tilesize, tilesize/4);		
	}
	

	
	//left and right
	for (int j=0;j<tiles;j++)
	{
		//left first
		blit(bmp_tiles, buffer, (worldmap[mapoffsetx-1][mapoffsety+j]%tilemap_tw)*tilesize+tilesize-tilesize/4, (worldmap[mapoffsetx-1][mapoffsety+j]/tilemap_tw)*tilesize,  0, ymargin+tilesize*j, tilesize/4, tilesize);		
		blit(bmp_tiles, buffer, (worldmap[mapoffsetx+tiles][mapoffsety+j]%tilemap_tw)*tilesize,(worldmap[mapoffsetx+tiles][mapoffsety+j]/tilemap_tw)*tilesize,  tiles*tilesize+xmargin,ymargin+tilesize*j, tilesize/4, tilesize);		
		
	}
	
	//corners
	
	//top left
	blit(bmp_tiles, buffer, (worldmap[mapoffsetx-1][mapoffsety-1]%tilemap_tw)*tilesize+tilesize-tilesize/4, (worldmap[mapoffsetx-1][mapoffsety-1]/tilemap_tw)*tilesize+tilesize-tilesize/4,  0, 0, tilesize/4, tilesize/4);		
	
	//top right
	blit(bmp_tiles, buffer, (worldmap[mapoffsetx+tiles][mapoffsety-1]%tilemap_tw)*tilesize, (worldmap[mapoffsetx+tiles][mapoffsety-1]/tilemap_tw)*tilesize+tilesize-tilesize/4,  tiles*tilesize+xmargin, 0, tilesize/4, tilesize/4);		
	
	//bottom left
	blit(bmp_tiles, buffer, (worldmap[mapoffsetx-1][mapoffsety+tiles]%tilemap_tw)*tilesize+tilesize-tilesize/4, (worldmap[mapoffsetx-1][mapoffsety+tiles]/tilemap_tw)*tilesize,  0, tiles*tilesize+ymargin, tilesize/4, tilesize/4);		

	
	//bottom right
	blit(bmp_tiles, buffer, (worldmap[mapoffsetx+tiles][mapoffsety+tiles]%tilemap_tw)*tilesize, (worldmap[mapoffsetx+tiles][mapoffsety+tiles]/tilemap_tw)*tilesize,  tiles*tilesize+xmargin, tiles*tilesize+ymargin, tilesize/4, tilesize/4);		
	
	//DRAW PLAYER
	
	masked_blit(bmp_tiles,buffer,(12+pdir)*tilesize,4*tilesize,(px-mapoffsetx)*tilesize+xmargin,(py-mapoffsety)*tilesize+ymargin,tilesize,tilesize);
	
	drawnpcs(mapoffsetx,mapoffsety);

}

void gameloop()
{
	if (quit)
		return;

	init_gamevars();
	
	
	
	
	while (!quit&&!gameover&!finishedscripts)
	{
		
		al_poll_duh(dplay);	

		while(speed_count>0)
		{
						
			if (key[KEY_ESC])
				return;
			
			int i=do_logic();
			if (i!=0)
			{
				gameover=true;
			};
			
			game_input();
						
		      speed_count--;
		}
		
		//		clear_to_color(buffer,makecol(150,50,50));
		
		drawmap();

		blit(bmp_title, buffer, 120, 0, 120, 0, 40, 120);

	
		if (showingdialog)
		{
			blit(bmp_textbox, buffer, 0, 0, 0, 86, 120, 34);
			printtextml(6,90,27,dialoguestring);
		}
		
		
		for (int i=0;i<4;i++)
		{
			if (hasitem[i])
				blit(bmp_tiles, buffer, (12+i)*tilesize, 11*tilesize, 133, 44+18*i, tilesize, tilesize);
		}
		
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
}

BITMAP *barimage;
BITMAP *poleflag;
BITMAP* inputimagesarray[4];
BITMAP* xbuttonbmp;

void init()
{
	srand(time(0));
	/* initialise everything */
	allegro_init();
	init_sound();
	
	//	int depth = desktop_color_depth();
	
	//	if (depth == 0) depth = 32;
	//		set_color_depth(depth);	
	set_color_depth(32);
	
	install_keyboard();
	install_timer();
	
	
#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
#endif
	
	set_alpha_blender();
	
    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));	
	
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;
	
	//init the buffer
	buffer=create_bitmap(160,120);
	
	//load font
	
	BITMAP* fontbmps =  load_bitmap("bmp/font.bmp", NULL);
	for (int i=0;i<36;i++)
	{
		fontbmp[i]=create_bitmap(3,5);
		blit(fontbmps,fontbmp[i],i*4,0,0,0,3,5);
	}
	
	delete fontbmps;
	
	bmp_title=load_bitmap("bmp/title.bmp",NULL);
	bmp_tiles=load_bitmap("bmp/tiles.bmp",NULL);
	bmp_textbox=load_bitmap("bmp/textbox.bmp",NULL);
	
	srand(time(0));
	
	for (int i=0;i<5;i++)
		nowdown[i]=1;
	
	BITMAP* bmp_tilemask=load_bitmap("bmp/tilemask.bmp",NULL);
	for (int i=0;i<tilemap_tw;i++)
	{	
		for (int j=0;j<tilemap_th;j++)
		{
			canpass[i+j*tilemap_tw]=getpixel(bmp_tilemask, i, j)!=makecol(0,0,0);
		}
	}
	release_bitmap(bmp_tilemask);

}

void init_gamevars()
{
	initmap();
	for (int i=0;i<4;i++)
	{
		hasitem[i]=false;
	}
	
	for (int i=0;i<5;i++)
		nowdown[i]=1;
	
}

int main(int argc, char *argv[])
{
	init();

	introloop();
	
	playmusic(0);	
	while (!quit)
	{
		titleloop();
				    
		gameloop();
	}
	
	return 0;
}
END_OF_MAIN()
